package com.example.iccard15693;

import android.os.Bundle;
import android.pt.iccard15693.IcCard15693;
import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class MainActivity extends Activity
{
	// private EditText ed_sendAPDU = null;
	private Button bt_openIcCard = null;
	private Button bt_close = null;
	private EditText ed_ResponseData = null;
	
	private IcCard15693 icCard = null;
	long mExitTime   = 0;
	boolean open_flg = false;
	
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		icCard = new IcCard15693();
		init_id();
	}
	
	public void show(Context context ,String msg) 
	{
		Toast.makeText(context, msg, Toast.LENGTH_SHORT).show();		
	}
	
	private void show_result(int ret)
	{
		switch(ret)
		{
			case 0:
				show(MainActivity.this,"success ");
				break;				
			case -1:
				show(MainActivity.this,"fail");
				break;
			case -2:
				show(MainActivity.this,"time out");
				break;
			case -3:
				show(MainActivity.this,"in parameters error");
				break;
			default:
				show(MainActivity.this,"fail");
				break;
		}
	}
	
	public void openIcCard(View view)
	{
		Log.i("123", "openNfc");
		if(open_flg)
		{
			show(MainActivity.this,"IcCard already open");
			return;
		}
		int ret = icCard.open();
		if(ret == 0)
		{
			open_flg = true;
		}
		show_result(ret);
		bt_openIcCard.setBackgroundColor(Color.rgb(0, 0, 255));
	}

	public void seek(View view)
	{
		if(!open_flg)
		{
			show(MainActivity.this,"Please open IcCard");
			return;
		}
		byte[] out_data = new byte[1024];
		
		int len = icCard.seek(out_data);

		String msg = "";
		Log.i("123", "len:"+len);
		for(int i=0;i<len;i++){
			
			Log.i("123", ""+(out_data[i]));
			msg = msg+Integer.toHexString((out_data[i]&0xff))+" ";
		}
		ed_ResponseData.setText(msg);
		if(len > 0){
			show_result(0);
		}else{
			show_result(-1);
		}
		//show_result(ret);
	}

	public void move_15693(View view)
	{
		if(!open_flg)
		{
			show(MainActivity.this,"Please open IcCard");
			return;
		}
		Log.i("123", "move");
		int ret = icCard.move();
		show_result(ret);
	}
	
	public void close(View view)
	{
		Log.i("123", "close");
		int ret = icCard.close();
		if(ret == 0)
		{
			open_flg = false;
		}
		show_result(ret);
		bt_close.setBackgroundColor(Color.rgb(0, 0, 255));
		System.exit(0);
	}
	
	public boolean onKeyDown(int keyCode, KeyEvent event)
	{
		if (keyCode == KeyEvent.KEYCODE_BACK )
		{
			if ((System.currentTimeMillis() - mExitTime) > 2000)  
			{
				Toast.makeText(this, "Once press again,exit program", Toast.LENGTH_SHORT).show();
				mExitTime = System.currentTimeMillis(); 
		    } 
			else
			{
				icCard.close();
				icCard = null;
			 	System.exit(0);
			}
			
			return true;
		}
		
		return super.onKeyDown(keyCode, event);
	}
	
	public void init_id()
	{
		//ed_sendAPDU = (EditText)findViewById(R.id.ed_sendAPDU);
		bt_openIcCard = (Button)findViewById(R.id.bt_openIcCard);
		bt_close = (Button)findViewById(R.id.bt_close);
		ed_ResponseData = (EditText)findViewById(R.id.ed_ResponseData);
	}
}